/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.dokumente.entity;

@javax.persistence.NamedQueries(
 {



       @javax.persistence.NamedQuery(
     name="DOKUMENT_VORLAGE.UK",
     query="SELECT o FROM DokumentVorlage o WHERE "

                         + "o"
                +".name"
              +" = ?1"

             +" AND "         + "o"
                +".wahltermin"
                +".nummer"
              +" = ?2"

             +" AND "         + "o"
                +".wahltermin"
                +".wahldatum"
              +" = ?3"

             +" AND "         + "o"
                +".wahltermin"
                +".mandant"
                +".nummer"
              +" = ?4"

     ,
   hints = {
              @javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
             @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
   }


   )
   
     ,   @javax.persistence.NamedQuery(
     name="DOKUMENT_VORLAGE.All",
     query="SELECT o FROM DokumentVorlage o",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="DOKUMENT_VORLAGE.WahlAndArtOrderByName",
     query="SELECT o FROM DokumentVorlage o WHERE o.wahl=?1 AND o.dokumentVorlageArt=?2 ORDER BY o.name",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="DOKUMENT_VORLAGE.WahlOrderByArtAndName",
     query="SELECT o FROM DokumentVorlage o WHERE o.wahl=?1 ORDER BY o.dokumentVorlageArt, o.name",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="DOKUMENT_VORLAGE.WahlterminAndArtAndName",
     query="SELECT o FROM DokumentVorlage o WHERE o.wahltermin=?1 AND o.dokumentVorlageArt = ?2 AND o.name = ?3",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="DOKUMENT_VORLAGE.WahlterminAndArtOrderByName",
     query="SELECT o FROM DokumentVorlage o WHERE o.wahltermin=?1 AND o.dokumentVorlageArt = ?2 ORDER BY o.name",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="DOKUMENT_VORLAGE.WahlterminOrderByArtAndName",
     query="SELECT o FROM DokumentVorlage o WHERE o.wahltermin=?1 ORDER BY o.dokumentVorlageArt, o.name",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "DOKUMENT_VORLAGE")
// @javax.persistence.IdClass(DokumentVorlagePK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class DokumentVorlage
extends AbstractDokumentVorlage
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor
   */
  public DokumentVorlage() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public DokumentVorlage(DokumentVorlage original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "dokument_vorlage_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "DokumentVorlage")
    @javax.persistence.TableGenerator(name = "DokumentVorlage", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "DokumentVorlage", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient DokumentVorlagePK pkCache;

  @Override
  public DokumentVorlagePK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new DokumentVorlagePK(getId());
    }

    return pkCache;
  }

  public static <E extends DokumentVorlage> java.util.Map<DokumentVorlagePK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<DokumentVorlagePK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends DokumentVorlage> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;



  public void resetAttributeChanged() {
        hasChangedAnlageArt = false;
          hasChangedBeschreibung = false;
          hasChangedDokumentVorlageArt = false;
          hasChangedName = false;
          hasChangedVersionsnummer = false;
  
      hasChangedDateiImport = false;
        hasChangedWahltermin = false;
        hasChangedWahl = false;
  


    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "ANLAGE_ART", nullable = DokumentVorlageConstants.ANLAGE_ART_NULLABLE)
    
  protected de.ivu.elect.business.dokumente.entity.DokumentVorlageAnlageArt anlageArt =  de.ivu.elect.business.dokumente.entity.DokumentVorlageAnlageArt.EINZEL_DATEI;

  @javax.persistence.Transient
  protected boolean hasChangedAnlageArt = false;

  public boolean hasChangedAnlageArt(){
    return hasChangedAnlageArt;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertAnlageArt = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.dokumente.entity.DokumentVorlageAnlageArt wertNachLadenAnlageArt;
  
  /**
   * 
   *
   * getter for DOKUMENT_VORLAGE.ANLAGE_ART
   */
    @Override   public  de.ivu.elect.business.dokumente.entity.DokumentVorlageAnlageArt getAnlageArt() {
        return anlageArt;
      }

  /**
   * 
   *
   * setter for DOKUMENT_VORLAGE.ANLAGE_ART
   *
   * @param anlageArt
   */
  @Override   public void setAnlageArt( de.ivu.elect.business.dokumente.entity.DokumentVorlageAnlageArt anlageArt) {

       resetTkCache();
                  de.ivu.elect.business.dokumente.entity.DokumentVorlageAnlageArt anlageArtInternal = anlageArt;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.anlageArt
      , anlageArtInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedAnlageArt |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("anlageArt");
      }


             if (!isSeitLadenVeraendertAnlageArt) {
          isSeitLadenVeraendertAnlageArt = thisAttributChanged;
         if (isSeitLadenVeraendertAnlageArt){
           wertNachLadenAnlageArt=this.anlageArt;
         }
       }
      

       this.anlageArt = anlageArtInternal;

         }

        
  @javax.persistence.Column(name = "BESCHREIBUNG", nullable = DokumentVorlageConstants.BESCHREIBUNG_NULLABLE, length=DokumentVorlageConstants.BESCHREIBUNG_MAX_LENGTH)
        
  protected java.lang.String beschreibung =  null;

  @javax.persistence.Transient
  protected boolean hasChangedBeschreibung = false;

  public boolean hasChangedBeschreibung(){
    return hasChangedBeschreibung;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertBeschreibung = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenBeschreibung;
  
  /**
   * 
   *
   * getter for DOKUMENT_VORLAGE.BESCHREIBUNG
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getBeschreibung() {
        return beschreibung;
      }

  /**
   * 
   *
   * setter for DOKUMENT_VORLAGE.BESCHREIBUNG
   *
   * @param beschreibung
   */
  @Override   public void setBeschreibung(@javax.annotation.Nullable  java.lang.String beschreibung) {

       resetTkCache();
                  
                          java.lang.String beschreibungInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(beschreibung, DokumentVorlageConstants.BESCHREIBUNG_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.beschreibung
      , beschreibungInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedBeschreibung |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("beschreibung");
      }


             if (!isSeitLadenVeraendertBeschreibung) {
          isSeitLadenVeraendertBeschreibung = thisAttributChanged;
         if (isSeitLadenVeraendertBeschreibung){
           wertNachLadenBeschreibung=this.beschreibung;
         }
       }
      

       this.beschreibung = beschreibungInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "DOKUMENT_VORLAGE_ART", nullable = DokumentVorlageConstants.DOKUMENT_VORLAGE_ART_NULLABLE)
    
  protected de.ivu.elect.business.dokumente.entity.DokumentVorlageArt dokumentVorlageArt =  null;

  @javax.persistence.Transient
  protected boolean hasChangedDokumentVorlageArt = false;

  public boolean hasChangedDokumentVorlageArt(){
    return hasChangedDokumentVorlageArt;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertDokumentVorlageArt = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.dokumente.entity.DokumentVorlageArt wertNachLadenDokumentVorlageArt;
  
  /**
   * 
   *
   * getter for DOKUMENT_VORLAGE.DOKUMENT_VORLAGE_ART
   */
    @Override   public  de.ivu.elect.business.dokumente.entity.DokumentVorlageArt getDokumentVorlageArt() {
        return dokumentVorlageArt;
      }

  /**
   * 
   *
   * setter for DOKUMENT_VORLAGE.DOKUMENT_VORLAGE_ART
   *
   * @param dokumentVorlageArt
   */
  @Override   public void setDokumentVorlageArt( de.ivu.elect.business.dokumente.entity.DokumentVorlageArt dokumentVorlageArt) {

       resetTkCache();
                  de.ivu.elect.business.dokumente.entity.DokumentVorlageArt dokumentVorlageArtInternal = dokumentVorlageArt;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.dokumentVorlageArt
      , dokumentVorlageArtInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedDokumentVorlageArt |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("dokumentVorlageArt");
      }


             if (!isSeitLadenVeraendertDokumentVorlageArt) {
          isSeitLadenVeraendertDokumentVorlageArt = thisAttributChanged;
         if (isSeitLadenVeraendertDokumentVorlageArt){
           wertNachLadenDokumentVorlageArt=this.dokumentVorlageArt;
         }
       }
      

       this.dokumentVorlageArt = dokumentVorlageArtInternal;

         }

        
      @javax.persistence.Column(name = "NAME", nullable = DokumentVorlageConstants.NAME_NULLABLE, length=DokumentVorlageConstants.NAME_MAX_LENGTH)
        
  protected java.lang.String name =  null;

  @javax.persistence.Transient
  protected boolean hasChangedName = false;

  public boolean hasChangedName(){
    return hasChangedName;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertName = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenName;
  
  /**
   * 
   *
   * getter for DOKUMENT_VORLAGE.NAME
   */
    @Override   public  java.lang.String getName() {
        return name;
      }

  /**
   * 
   *
   * setter for DOKUMENT_VORLAGE.NAME
   *
   * @param name
   */
  @Override   public void setName( java.lang.String name) {

       resetTkCache();
                  
                          java.lang.String nameInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(name, DokumentVorlageConstants.NAME_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.name
      , nameInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedName |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("name");
      }


             if (!isSeitLadenVeraendertName) {
          isSeitLadenVeraendertName = thisAttributChanged;
         if (isSeitLadenVeraendertName){
           wertNachLadenName=this.name;
         }
       }
      

       this.name = nameInternal;

         }

        
  @javax.persistence.Column(name = "VERSIONSNUMMER", nullable = DokumentVorlageConstants.VERSIONSNUMMER_NULLABLE, length=DokumentVorlageConstants.VERSIONSNUMMER_MAX_LENGTH)
        
  protected java.lang.String versionsnummer =  null;

  @javax.persistence.Transient
  protected boolean hasChangedVersionsnummer = false;

  public boolean hasChangedVersionsnummer(){
    return hasChangedVersionsnummer;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertVersionsnummer = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenVersionsnummer;
  
  /**
   * 
   *
   * getter for DOKUMENT_VORLAGE.VERSIONSNUMMER
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getVersionsnummer() {
        return versionsnummer;
      }

  /**
   * 
   *
   * setter for DOKUMENT_VORLAGE.VERSIONSNUMMER
   *
   * @param versionsnummer
   */
  @Override   public void setVersionsnummer(@javax.annotation.Nullable  java.lang.String versionsnummer) {

       resetTkCache();
                  
                          java.lang.String versionsnummerInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(versionsnummer, DokumentVorlageConstants.VERSIONSNUMMER_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.versionsnummer
      , versionsnummerInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedVersionsnummer |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("versionsnummer");
      }


             if (!isSeitLadenVeraendertVersionsnummer) {
          isSeitLadenVeraendertVersionsnummer = thisAttributChanged;
         if (isSeitLadenVeraendertVersionsnummer){
           wertNachLadenVersionsnummer=this.versionsnummer;
         }
       }
      

       this.versionsnummer = versionsnummerInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu DateiImport
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "DATEI_IMPORT_ID", referencedColumnName="DATEI_IMPORT_ID"))
  protected de.ivu.elect.business.datei.entity.DateiImport dateiImport;

  /**
   * 
   */
  @Override
  public void setDateiImport( de.ivu.elect.business.datei.entity.DateiImport dateiImport){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.dateiImport
    , dateiImport);

    attributeChanged |= thisAttributChanged;

    hasChangedDateiImport |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("dateiImport");
    }

    this.dateiImport = dateiImport;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.datei.entity.DateiImport getDateiImport(){
    return this.dateiImport;
  }

  @javax.persistence.Transient
  protected boolean hasChangedDateiImport = false;

  public boolean hasChangedDateiImport(){
    return hasChangedDateiImport;
  }

  /**
   * Beziehung (unidirektional) zu Wahltermin
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "WAHLTERMIN_ID", referencedColumnName="WAHLTERMIN_ID"))
  protected de.ivu.elect.business.wahl.entity.Wahltermin wahltermin;

  /**
   * 
   */
  @Override
  public void setWahltermin( de.ivu.elect.business.wahl.entity.Wahltermin wahltermin){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.wahltermin
    , wahltermin);

    attributeChanged |= thisAttributChanged;

    hasChangedWahltermin |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("wahltermin");
    }

    this.wahltermin = wahltermin;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.wahl.entity.Wahltermin getWahltermin(){
    return this.wahltermin;
  }

  @javax.persistence.Transient
  protected boolean hasChangedWahltermin = false;

  public boolean hasChangedWahltermin(){
    return hasChangedWahltermin;
  }

  /**
   * Beziehung (unidirektional) zu Wahl
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=true, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "WAHL_ID", referencedColumnName="WAHL_ID"))
  protected de.ivu.elect.business.wahl.entity.Wahl wahl;

  /**
   * 
   */
  @Override
  public void setWahl(@javax.annotation.Nullable  de.ivu.elect.business.wahl.entity.Wahl wahl){
    resetTkCache();
           de.ivu.elect.business.wahl.entity.Wahl alterWert = getWahl();
       preSetWahl(alterWert, wahl);
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.wahl
    , wahl);

    attributeChanged |= thisAttributChanged;

    hasChangedWahl |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("wahl");
    }

    this.wahl = wahl;
         postSetWahl(alterWert, wahl);
      }

  /**
   * 
   */
  @javax.annotation.Nullable   @Override
  public de.ivu.elect.business.wahl.entity.Wahl getWahl(){
    return this.wahl;
  }

  @javax.persistence.Transient
  protected boolean hasChangedWahl = false;

  public boolean hasChangedWahl(){
    return hasChangedWahl;
  }


/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("DokumentVorlage:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(DokumentVorlage other){
                             other.anlageArt = this.anlageArt;
                                other.beschreibung = this.beschreibung;
                                other.dokumentVorlageArt = this.dokumentVorlageArt;
                                other.name = this.name;
                                other.versionsnummer = this.versionsnummer;
           
  other.setDateiImport(this.getDateiImport());
  other.setWahltermin(this.getWahltermin());
  other.setWahl(this.getWahl());


  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(DokumentVorlage.class)){
        copyEntityAttributesUsingSetter((DokumentVorlage) other.castTo(DokumentVorlage.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von DokumentVorlage: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(DokumentVorlage other){
               other.setAnlageArt(this.anlageArt);
                  other.setBeschreibung(this.beschreibung);
                  other.setDokumentVorlageArt(this.dokumentVorlageArt);
                  other.setName(this.name);
                  other.setVersionsnummer(this.versionsnummer);
       
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(DokumentVorlage other){
                       if (hasChangedAnlageArt) {
        other.setAnlageArt(this.anlageArt);
      }
                             if (hasChangedBeschreibung) {
        other.setBeschreibung(this.beschreibung);
      }
                             if (hasChangedDokumentVorlageArt) {
        other.setDokumentVorlageArt(this.dokumentVorlageArt);
      }
                             if (hasChangedName) {
        other.setName(this.name);
      }
                             if (hasChangedVersionsnummer) {
        other.setVersionsnummer(this.versionsnummer);
      }
             }





    @javax.persistence.Transient
    private transient DokumentVorlageTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public DokumentVorlageTK getDokumentVorlageTK(){
    if (tkCache==null) {
    tkCache = new DokumentVorlageTK(



  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getDokumentVorlageTK();
    }

  @Override
  public DokumentVorlageUK getUk(){
    return getDokumentVorlageUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return DokumentVorlage.class;
  }

public DokumentVorlageUK getDokumentVorlageUK(){

   return  new DokumentVorlageUK(

getName()
,     getWahltermin()==null?null:getWahltermin().getWahlterminUK()


  );
}

  @javax.persistence.Transient
  private transient DokumentVorlageProperties properties;

  public DokumentVorlageProperties getProperties(){
    if (properties == null) {
      properties = new DokumentVorlageProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public DokumentVorlageProperties getDokumentVorlageProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return DokumentVorlageConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
     
      if (werteVorher.containsKey(DokumentVorlageConstants.MESSAGE_KEY_ANLAGE_ART_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(DokumentVorlageConstants.MESSAGE_KEY_ANLAGE_ART_EINZAHL);

        anlageArt =
     (de.ivu.elect.business.dokumente.entity.DokumentVorlageAnlageArt) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(DokumentVorlageConstants.MESSAGE_KEY_BESCHREIBUNG_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(DokumentVorlageConstants.MESSAGE_KEY_BESCHREIBUNG_EINZAHL);

        beschreibung =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(DokumentVorlageConstants.MESSAGE_KEY_DOKUMENT_VORLAGE_ART_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(DokumentVorlageConstants.MESSAGE_KEY_DOKUMENT_VORLAGE_ART_EINZAHL);

        dokumentVorlageArt =
     (de.ivu.elect.business.dokumente.entity.DokumentVorlageArt) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(DokumentVorlageConstants.MESSAGE_KEY_NAME_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(DokumentVorlageConstants.MESSAGE_KEY_NAME_EINZAHL);

        name =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(DokumentVorlageConstants.MESSAGE_KEY_VERSIONSNUMMER_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(DokumentVorlageConstants.MESSAGE_KEY_VERSIONSNUMMER_EINZAHL);

        versionsnummer =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                        if (isSeitLadenVeraendertAnlageArt) {
      result.put(DokumentVorlageConstants.MESSAGE_KEY_ANLAGE_ART_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenAnlageArt , anlageArt));
    }
                            if (isSeitLadenVeraendertBeschreibung) {
      result.put(DokumentVorlageConstants.MESSAGE_KEY_BESCHREIBUNG_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenBeschreibung , beschreibung));
    }
                            if (isSeitLadenVeraendertDokumentVorlageArt) {
      result.put(DokumentVorlageConstants.MESSAGE_KEY_DOKUMENT_VORLAGE_ART_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenDokumentVorlageArt , dokumentVorlageArt));
    }
                            if (isSeitLadenVeraendertName) {
      result.put(DokumentVorlageConstants.MESSAGE_KEY_NAME_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenName , name));
    }
                            if (isSeitLadenVeraendertVersionsnummer) {
      result.put(DokumentVorlageConstants.MESSAGE_KEY_VERSIONSNUMMER_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenVersionsnummer , versionsnummer));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                      isSeitLadenVeraendertAnlageArt = false;
      wertNachLadenAnlageArt = null;
                          isSeitLadenVeraendertBeschreibung = false;
      wertNachLadenBeschreibung = null;
                          isSeitLadenVeraendertDokumentVorlageArt = false;
      wertNachLadenDokumentVorlageArt = null;
                          isSeitLadenVeraendertName = false;
      wertNachLadenName = null;
                          isSeitLadenVeraendertVersionsnummer = false;
      wertNachLadenVersionsnummer = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                    if (dateiImport != null) {
          if (!result.contains(dateiImport)) {
            de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode node = new de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode(DokumentVorlageConstants.MESSAGE_KEY_DATEI_IMPORT_ID_EINZAHL, dateiImport);
            result.add(node);
            node.getChildren().addAll(dateiImport.getFachlichAbhaengigeEntitaeten());
          }
        }
                            return result;
  }

        
            protected String getInitialDiscriminator() {
              return "DOKUMENT_VORLAGE";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "DokumentVorlage";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

    @Override
    public int hashCode() {

      if (id==null){
        return super.hashCode();
      }
      return id.hashCode();
    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(anlageArt, this, DokumentVorlageConstants.MESSAGE_KEY_ANLAGE_ART_EINZAHL, validationResult);
                                                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(DokumentVorlageConstants.BESCHREIBUNG_MAX_LENGTH ,  beschreibung, this, DokumentVorlageConstants.MESSAGE_KEY_BESCHREIBUNG_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(dokumentVorlageArt, this, DokumentVorlageConstants.MESSAGE_KEY_DOKUMENT_VORLAGE_ART_EINZAHL, validationResult);
                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(name, this, DokumentVorlageConstants.MESSAGE_KEY_NAME_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(DokumentVorlageConstants.NAME_MAX_LENGTH , 1 ,  name, this, DokumentVorlageConstants.MESSAGE_KEY_NAME_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(DokumentVorlageConstants.VERSIONSNUMMER_MAX_LENGTH ,  versionsnummer, this, DokumentVorlageConstants.MESSAGE_KEY_VERSIONSNUMMER_EINZAHL, validationResult);
                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        private transient java.util.Map<String, Object> transientContext;

        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }

              }
